<script setup>
// imports
import MenuIcon from "@/components/icons/MenuIcon.vue";
import RefreshIcon from "@/components/icons/RefreshIcon.vue";
import UserIcon from "@/components/icons/UserIcon.vue";
import LoadingComponent from "@/components/main/LoadingComponent.vue";
import PriceCardComponent from "@/components/main/PriceCardComponent.vue";
import { api, error_handler } from "@/services/api.service";
import { inject, ref, watch } from "vue";
import { push } from "notivue";
import { useBaseStore } from "@/stores/base";
import IconLogout from "@/components/icons/IconLogout.vue";
import PriceCardComponentType1 from "@/components/main/PriceCardComponentType1.vue";
import PriceCardComponentType2 from "@/components/main/PriceCardComponentType2.vue";
// cookie
let $cookies = inject("$cookies");
// store
const baseStore = useBaseStore();
// data
const loading = ref(true);
const rollingLoading = ref(false);
const data = ref();
const showMenu = ref(false);
// methods
watch(showMenu, () => {
  if (showMenu.value) {
    document.body?.classList?.add("hidden-body");
  } else {
    document.body?.classList?.remove("hidden-body");
  }
});

const getLatestPrices = () => {
  if (data.value?.length > 0) {
    rollingLoading.value = true;
  } else {
    loading.value = true;
  }
  api
    .get("https://www.ayandehexchange.com/API/get_rates")
    .then((res) => {
      data.value = res.data.data;
      if (rollingLoading.value) push.success("Prices has been updated!");
    })
    .catch(() => {
      error_handler();
    })
    .finally(() => {
      loading.value = false;
      rollingLoading.value = false;
    });
};
if (!data.value) getLatestPrices();

const logOutHandler = () => {
  loading.value = true;
  baseStore.is_user_logged_in = false;
  baseStore.user = null;
  $cookies.remove("jwt");
  setTimeout(() => {
    getLatestPrices();
  }, 600);
};
</script>
<template>
  <LoadingComponent v-if="loading" />
  <div
    v-else
    :class="{ 'overflow-y-hidden': showMenu }"
    class="max-w-[468px] p-8 mx-auto bg-bg-primary h-full overflow-y-auto relative"
  >
    <div
      @click.self="showMenu = false"
      :class="{ '!opacity-100 !visible': showMenu }"
      class="absolute z-[9] bg-[#ffffff22] backdrop-blur inset-0 opacity-0 invisible transition-all"
    ></div>

    <div
      :class="{ '!left-0': showMenu }"
      class="absolute bg-white z-10 w-[300px] left-[-320px] shadow-lg top-0 bottom-0 overflow-y-auto p-6 transition-all"
    >
      <img src="/logo-ayandeh.png" class="w-14" alt="ayandeh exchange" />
      <div class="flex flex-col gap-4 mt-10">
        <router-link to="/about" class="text-txt-primary">
          About us
        </router-link>
        <router-link to="/contact" class="text-txt-primary">
          Contact us
        </router-link>
        <router-link to="/branches" class="text-txt-primary">
          Branches
        </router-link>
      </div>
      <div
        class="text-[13px] font-light text-txt-secondary absolute bottom-7 left-[50%] translate-x-[-50%]"
      >
        Version 1.0
      </div>
    </div>

    <div class="flex items-center justify-between gap-3">
      <img src="/logo-ayandeh.png" class="w-20" alt="ayandeh exchange" />
      <div class="flex items-center gap-4">
        <router-link v-if="!baseStore.is_user_logged_in" to="/login">
          <UserIcon class="user-icon" />
        </router-link>
        <MenuIcon @click="showMenu = true" class="text-gray-700" />
      </div>
    </div>

    <template v-if="baseStore.is_user_logged_in">
      <div
        class="bg-white rounded-t-lg p-3 flex items-center justify-between gap-2 mt-5"
      >
        <div class="flex items-center gap-4 truncate">
          <div
            class="w-[33.33px] h-[33.33px] min-w-[33.33px] rounded-full overflow-hidden"
          >
            <img
              :src="
                !!baseStore.user.customer_avatar
                  ? baseStore.user.customer_avatar
                  : '/avatar.png'
              "
              :alt="baseStore.user.customer_first_name"
              class="w-full h-full object-cover"
            />
          </div>
          <div class="flex flex-col gap-1 truncate">
            <div
              class="text-txt-primary font-semibold text-[15px] max-w-[140px] truncate"
            >
              {{
                baseStore?.user.customer_first_name +
                " " +
                baseStore?.user.customer_last_name
              }}
            </div>
          </div>
        </div>
        <button
          @click="logOutHandler"
          class="h-[33.33px] px-3 rounded-full bg-black flex items-center justify-center text-[14px]"
        >
          <IconLogout class="text-white w-[16px] mr-2" />
          <span class="text-white">Log out</span>
        </button>
      </div>
      <div class="flex items-center justify-between gap-2 bg-white border-t border-neutral-100 rounded-b-lg p-3">
        <div class="text-txt-primary font-semibold text-[13px]">
        Type : {{ baseStore?.user.customer_type_title }}
      </div>
      <div class="h-4 bg-neutral-100 w-[1px]"></div>
      <div class="text-txt-primary font-semibold text-[13px]">
        CN : {{ baseStore?.user.customer_number }}
      </div>
      </div>
    </template>
    <div v-else class="flex flex-col items-center">
      <div class="font-bold text-[15px] text-txt-primary">Rates are for</div>
      <div class="font-extrabold text-[35px] text-txt-blue">Guests</div>
      <div class="font-bold text-[15px] text-txt-primary">
        Login for get your rate
      </div>
    </div>

    <div class="flex items-center gap-2 mt-10">
      <div v-if="data" class="font-bold text-[15px] text-txt-low">
        {{ data[0]?.price_type_1[0]?.created_at }}
      </div>
      <RefreshIcon
        @click="getLatestPrices"
        :class="{ 'rolling-class': rollingLoading }"
        class="text-txt-primary"
      />
    </div>
    <div
      v-if="!baseStore.is_user_logged_in"
      class="grid grid-cols-2 gap-3 mt-4"
    >
      <template v-for="(price, index) in data" :key="index + 'price'">
        <PriceCardComponent
          v-if="price?.price_type_1[1]?.sell_price"
          :price="price"
        />
      </template>
    </div>
    <div
      v-if="baseStore.is_user_logged_in && baseStore.user.customer_type === '0'"
      class="grid grid-cols-2 gap-3 mt-4"
    >
      <template v-for="(price, index) in data" :key="index + 'price'">
        <PriceCardComponent
          v-if="price?.price_type_1[1]?.sell_price"
          :price="price"
        />
      </template>
    </div>
    <div
      v-if="baseStore.is_user_logged_in && baseStore.user.customer_type === '1'"
      class="grid grid-cols-2 gap-3 mt-4"
    >
      <template v-for="(price, index) in data" :key="index + 'price'">
        <PriceCardComponentType1
          v-if="price?.price_type_2[1]?.sell_price"
          :price="price"
        />
      </template>
    </div>
    <div
      v-if="baseStore.is_user_logged_in && baseStore.user.customer_type === '2'"
      class="grid grid-cols-2 gap-3 mt-4"
    >
      <template v-for="(price, index) in data" :key="index + 'price'">
        <PriceCardComponentType2
          v-if="price?.price_type_3[1]?.sell_price"
          :price="price"
        />
      </template>
    </div>
  </div>
</template>
<style scoped>
.rolling-class {
  animation: rolling 1s linear infinite;
}
@keyframes rolling {
  from {
    transform: rotate(0deg);
  }
  to {
    transform: rotate(360deg);
  }
}
</style>
